#include <stdio.h>
#include <stdlib.h>

#define MAX 100

void greska(){
	printf("-1");
	exit(EXIT_FAILURE);
}

int pretraga(int a[], int levo, int desno, int x){
	if(levo > desno){
		return -1;
	}
	else{
		int sredina = (levo + desno) / 2;
		//3 slucaja: 
		//1. ako je x manji do srednjeg
		//2. ako je x jednak srednjem
		//3. ako je x veci od srednjeg
		if(x < a[sredina])
			return pretraga(a, levo, sredina - 1, x);
		else if(x == a[sredina])
			return sredina;
		else if(x > a[sredina])
			return pretraga(a, sredina + 1, desno, x);
	}
}

int poredi(const void *a, const void *b);

int main(){
	int n;
	printf("Unesite duzinu niza\n");
	scanf("%d", &n);
	
	//provera
	if(n > MAX || n < 0)
		greska();
	
	int niz[MAX];
	int i;
	for(i = 0; i < n; i++)
		scanf("%d", &niz[i]);
	
	printf("Unesite kljuc za pretragu\n");
	int x;
	scanf("%d", &x);
	//binarna pretraga trazi x izmedju leve i desne
	//granice, na pocetku su to 0 i n-1
	i = pretraga(niz, 0, n-1, x);
	
	if(i == -1)
		printf("broj nije pronadjen\n");
	else
		printf("broj je pronadjen na indeksu %d\n", i);
	
	
	//rezultat bsearch-a je naravno isto adresa
	//adresa elemenata u nizu koji je pronadjen
	//ako nije pronadjen onda je NULL
	int* rez = bsearch(&x, niz, n, sizeof(int), poredi);
	
	if(rez == NULL)
		printf("broj nije pronadjen\n");
	else
		printf("broj je pronadjen na indeksu %d\n", rez - niz);
}

int poredi(const void *a, const void *b){
	int x = *((int*)a);
	int y = *((int*)b);
	return x - y;
}