#include <stdio.h>
#include <stdlib.h>

#define MAX 100

void greska(){
	printf("-1");
	exit(EXIT_FAILURE);
}

int binarna_pretraga(int a[], int l, int d, int x){
	//za vezbu iterativna varijanta, sa while ciklusom
	if(l > d){
		return -1;
	}
	else{
		int s = (l + d) / 2;
		//3 slucaja
		//x je levo od srednjeg
		//x je jednak srednjem
		//x je desno od srednjeg
		
		if(x < a[s])
			return binarna_pretraga(a, l, s - 1, x);
		else if(x == a[s])
			return s;
		else if(x > a[s])
			return binarna_pretraga(a, s + 1, d, x);
	}
}

int poredi(const void *a, const void *b){
	//a je adresa kljuca
	int x = *((int*)a);
	//b je adresa odgovarajuceg elementa niza
	int s = *((int*)b);
	
	return x - s;
}

int main(){
	int n;
	printf("Unesite duzinu niza\n");
	scanf("%d", &n);
	
	if(n > MAX || n < 0)
		greska();
	
	int a[MAX];
	
	//ucitavanje
	int i;
	for(i = 0; i < n; i++)
		scanf("%d", &a[i]);
	
	printf("Unesite broj koji se pretrazuje\n");
	int x;
	scanf("%d", &x);
	
	i = binarna_pretraga(a, 0, n-1, x);
	if(i == -1)
		printf("Broj nije pronadjen\n");
	else
		printf("Broj je pronadjen na indeksu %d\n", i);
	
	//kao rezultat vraca void*, a to je adresa elementa u nizu koji je 
	//pronadjen, ako ga nema onda je NULL
	int *rez = bsearch(&x, a, n, sizeof(int), poredi);
	
	printf("Ugradjena binarna\n");
	if(rez == NULL)
		printf("Broj nije pronadjen\n");
	else
		printf("Broj je pronadjen na indeksu %d\n", rez - a);
}